#!/usr/bin/env python3

import gi, sys

gi.require_version('Gtk', '3.0')
from gi.repository import Gtk, GdkPixbuf

from assets import image_dict


class AboutWindow(Gtk.AboutDialog):
  def __init__(self):
    super().__init__(self)
    
    self.set_keep_above(True)
    
    self.set_program_name('Sonist Gtk')
    if sys.platform == 'linux':
      self.set_logo_icon_name('sonist')
    else:
      self.set_logo(GdkPixbuf.Pixbuf.new_from_file(image_dict['sonist']))

    self.set_license_type(Gtk.License.MIT_X11)
    self.set_version('1.0.0')
    self.set_website('https://github.com/app-cat/sonist-gtk')
    self.set_website_label('官网')
    self.set_authors([
      'Yutent <yutent.io@gmail.com> (Sonist)',
      'Mic92 <https://github.com/Mic92/python-mpd2> (python-mpd2)',
      'quodlibet <https://github.com/quodlibet/mutagen> (python-mutagen)'
    ])
    self.set_copyright('© 2023 Yutent <yutent.io@gmail.com>')
    self.set_comments('Sonist-Gtk 是一个界面美观, 基于MPD后端的音乐播放器, 使用python + gtk3开发。')

    self.connect("response", self.on_close)


  def on_close(self, dialog,  res):
    self.hide()